OpenVDB: PointIndexLeafNode< T, Log2Dim > Struct Template Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
PointIndexLeafNode< T, Log2Dim > Struct Template Reference

`#include <openvdb/tools/PointIndexGrid.h>`

Inheritance diagram for PointIndexLeafNode< T, Log2Dim >:

## Public Types
using | LeafNodeType = PointIndexLeafNode<T, Log2Dim>
using | Ptr = SharedPtr<PointIndexLeafNode>
using | ValueType = T
using | IndexArray = std::vector<ValueType>
using | BaseLeaf = tree::LeafNode<T, Log2Dim>
using | NodeMaskType = util::NodeMask<Log2Dim>
using | ValueOnIter
using | ValueOnCIter
using | ValueOffIter
using | ValueOffCIter
using | ValueAllIter
using | ValueAllCIter
using | ChildOnIter
using | ChildOnCIter
using | ChildOffIter
using | ChildOffCIter
using | ChildAllIter
using | ChildAllCIter
using | BuildType = T
using | Buffer = LeafBuffer<ValueType, Log2Dim>

## Public Member Functions
IndexArray & | indices ()
const IndexArray & | indices () const
bool | getIndices (const Coord &ijk, const ValueType *&begin, const ValueType *&end) const
bool | getIndices (Index offset, const ValueType *&begin, const ValueType *&end) const
void | setOffsetOn (Index offset, const ValueType &val)
void | setOffsetOnly (Index offset, const ValueType &val)
bool | isEmpty (const CoordBBox &bbox) const
| PointIndexLeafNode ()
| Default constructor.
| PointIndexLeafNode (const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
| PointIndexLeafNode (PartialCreate, const Coord &coords, const T &value=zeroVal< T >(), bool active=false)
| PointIndexLeafNode (const PointIndexLeafNode &rhs)
| Deep copy constructor.
template<typename OtherType, Index OtherLog2Dim>
bool | hasSameTopology (const PointIndexLeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.
bool | operator== (const PointIndexLeafNode &other) const
| Check for buffer, state and origin equivalence.
bool | operator!= (const PointIndexLeafNode &other) const
template<MergePolicy Policy>
void | merge (const PointIndexLeafNode &rhs)
template<MergePolicy Policy>
void | merge (const ValueType &tileValue, bool tileActive)
template<MergePolicy Policy>
void | merge (const PointIndexLeafNode &other, const ValueType &, const ValueType &)
void | addLeaf (PointIndexLeafNode *)
template<typename AccessorT>
void | addLeafAndCache (PointIndexLeafNode *, AccessorT &)
PointIndexLeafNode * | touchLeaf (const Coord &)
| Return a pointer to this node.
template<typename AccessorT>
PointIndexLeafNode * | touchLeafAndCache (const Coord &, AccessorT &)
template<typename NodeT, typename AccessorT>
NodeT * | probeNodeAndCache (const Coord &, AccessorT &)
PointIndexLeafNode * | probeLeaf (const Coord &)
template<typename AccessorT>
PointIndexLeafNode * | probeLeafAndCache (const Coord &, AccessorT &)
const PointIndexLeafNode * | probeConstLeaf (const Coord &) const
| Return a const pointer to this node.
template<typename AccessorT>
const PointIndexLeafNode * | probeConstLeafAndCache (const Coord &, AccessorT &) const
template<typename AccessorT>
const PointIndexLeafNode * | probeLeafAndCache (const Coord &, AccessorT &) const
const PointIndexLeafNode * | probeLeaf (const Coord &) const
template<typename NodeT, typename AccessorT>
const NodeT * | probeConstNodeAndCache (const Coord &, AccessorT &) const
void | readBuffers (std::istream &is, bool fromHalf=false)
void | readBuffers (std::istream &is, const CoordBBox &, bool fromHalf=false)
void | writeBuffers (std::ostream &os, bool toHalf=false) const
Index64 | memUsage () const
Index64 | memUsageIfLoaded () const
void | assertNonmodifiable ()
void | setActiveState (const Coord &, bool)
void | setActiveState (Index, bool)
void | setValueOnly (const Coord &, const ValueType &)
void | setValueOnly (Index, const ValueType &)
void | setValueOff (const Coord &)
void | setValueOff (Index)
void | setValueOff (const Coord &, const ValueType &)
void | setValueOff (Index, const ValueType &)
void | setValueOn (const Coord &)
void | setValueOn (Index)
void | setValueOn (const Coord &, const ValueType &)
void | setValueOn (Index, const ValueType &)
void | setValue (const Coord &, const ValueType &)
void | setValuesOn ()
void | setValuesOff ()
template<typename ModifyOp>
void | modifyValue (Index, const ModifyOp &)
template<typename ModifyOp>
void | modifyValue (const Coord &, const ModifyOp &)
template<typename ModifyOp>
void | modifyValueAndActiveState (const Coord &, const ModifyOp &)
void | clip (const CoordBBox &, const ValueType &)
void | fill (const CoordBBox &, const ValueType &, bool)
void | fill (const ValueType &)
void | fill (const ValueType &, bool)
template<typename AccessorT>
void | setValueOnlyAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename ModifyOp, typename AccessorT>
void | modifyValueAndActiveStateAndCache (const Coord &, const ModifyOp &, AccessorT &)
template<typename AccessorT>
void | setValueOffAndCache (const Coord &, const ValueType &, AccessorT &)
template<typename AccessorT>
void | setActiveStateAndCache (const Coord &, bool, AccessorT &)
void | resetBackground (const ValueType &, const ValueType &)
void | signedFloodFill (const ValueType &)
void | signedFloodFill (const ValueType &, const ValueType &)
void | negate ()
ValueOnCIter | cbeginValueOn () const
ValueOnCIter | beginValueOn () const
ValueOnIter | beginValueOn ()
ValueOffCIter | cbeginValueOff () const
ValueOffCIter | beginValueOff () const
ValueOffIter | beginValueOff ()
ValueAllCIter | cbeginValueAll () const
ValueAllCIter | beginValueAll () const
ValueAllIter | beginValueAll ()
ValueOnCIter | cendValueOn () const
ValueOnCIter | endValueOn () const
ValueOnIter | endValueOn ()
ValueOffCIter | cendValueOff () const
ValueOffCIter | endValueOff () const
ValueOffIter | endValueOff ()
ValueAllCIter | cendValueAll () const
ValueAllCIter | endValueAll () const
ValueAllIter | endValueAll ()
ChildOnCIter | cbeginChildOn () const
ChildOnCIter | beginChildOn () const
ChildOnIter | beginChildOn ()
ChildOffCIter | cbeginChildOff () const
ChildOffCIter | beginChildOff () const
ChildOffIter | beginChildOff ()
ChildAllCIter | cbeginChildAll () const
ChildAllCIter | beginChildAll () const
ChildAllIter | beginChildAll ()
ChildOnCIter | cendChildOn () const
ChildOnCIter | endChildOn () const
ChildOnIter | endChildOn ()
ChildOffCIter | cendChildOff () const
ChildOffCIter | endChildOff () const
ChildOffIter | endChildOff ()
ChildAllCIter | cendChildAll () const
ChildAllCIter | endChildAll () const
ChildAllIter | endChildAll ()
void | nodeCount (std::vector< Index64 > &) const
| no-op
void | nodeCount (std::vector< Index32 > &) const
Index64 | onVoxelCount () const
| Return the number of voxels marked On.
Index64 | offVoxelCount () const
| Return the number of voxels marked Off.
Index64 | onLeafVoxelCount () const
Index64 | offLeafVoxelCount () const
bool | isEmpty () const
| Return `true` if this node has no active voxels.
bool | isDense () const
| Return `true` if this node contains only active voxels.
bool | isAllocated () const
| Return `true` if memory for this node's buffer has been allocated.
bool | allocate ()
| Allocate memory for this node's buffer if it has not already been allocated.
void | evalActiveBoundingBox (CoordBBox &bbox, bool visitVoxels=true) const
CoordBBox | getNodeBoundingBox () const
| Return the bounding box of this node, i.e., the full index space spanned by this leaf node.
void | setOrigin (const Coord &origin)
| Set the grid index coordinates of this node's local origin.
const Coord & | origin () const
| Return the grid index coordinates of this node's local origin.
void | getOrigin (Coord &origin) const
void | getOrigin (Int32 &x, Int32 &y, Int32 &z) const
Coord | offsetToGlobalCoord (Index n) const
| Return the global coordinates for a linear table offset.
Index32 | transientData () const
| Return the transient data value.
void | setTransientData (Index32 transientData)
| Set the transient data value.
std::string | str () const
| Return a string representation of this node.
template<typename OtherType, Index OtherLog2Dim>
bool | hasSameTopology (const LeafNode< OtherType, OtherLog2Dim > *other) const
| Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.
bool | operator== (const LeafNode &other) const
| Check for buffer, state and origin equivalence.
bool | operator!= (const LeafNode &other) const
void | swap (Buffer &other)
| Exchange this node's data buffer with the given data buffer without changing the active states of the values.
const Buffer & | buffer () const
Buffer & | buffer ()
void | readTopology (std::istream &is, bool fromHalf=false)
| Read in just the topology.
void | writeTopology (std::ostream &os, bool toHalf=false) const
| Write out just the topology.
size_t | streamingSize (bool toHalf=false) const
const ValueType & | getValue (const Coord &xyz) const
| Return the value of the voxel at the given coordinates.
const ValueType & | getValue (Index offset) const
| Return the value of the voxel at the given linear offset.
template<typename AccessorT>
const ValueType & | getValue (const Coord &xyz, bool &state, int &level, AccessorT &) const
| Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level.
bool | probeValue (const Coord &xyz, ValueType &val) const
| Return `true` if the voxel at the given coordinates is active.
bool | probeValue (Index offset, ValueType &val) const
| Return `true` if the voxel at the given offset is active.
bool | isValueOn (const Coord &xyz) const
| Return `true` if the voxel at the given coordinates is active.
bool | isValueOn (Index offset) const
| Return `true` if the voxel at the given offset is active.
bool | isValueOff (const Coord &xyz) const
| Return `true` if the voxel at the given coordinates is inactive.
bool | isValueOff (Index offset) const
| Return `true` if the voxel at the given offset is inactive.
void | denseFill (const CoordBBox &bbox, const ValueType &value, bool active=true)
| Set all voxels within an axis-aligned box to the specified value and active state.
template<typename DenseT>
void | copyToDense (const CoordBBox &bbox, DenseT &dense) const
| Copy into a dense grid the values of the voxels that lie within a given bounding box.
template<typename DenseT>
void | copyFromDense (const CoordBBox &bbox, const DenseT &dense, const ValueType &background, const ValueType &tolerance)
| Copy from a dense grid into this node the values of the voxels that lie within a given bounding box.
template<typename AccessorT>
const ValueType & | getValueAndCache (const Coord &xyz, AccessorT &) const
| Return the value of the voxel at the given coordinates.
template<typename AccessorT>
bool | isValueOnAndCache (const Coord &xyz, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active.
template<typename AccessorT>
void | setValueAndCache (const Coord &xyz, const ValueType &val, AccessorT &)
| Change the value of the voxel at the given coordinates and mark it as active.
template<typename ModifyOp, typename AccessorT>
void | modifyValueAndCache (const Coord &xyz, const ModifyOp &op, AccessorT &)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.
template<typename AccessorT>
bool | probeValueAndCache (const Coord &xyz, ValueType &val, AccessorT &) const
| Return `true` if the voxel at the given coordinates is active and return the voxel value in val.
const ValueType & | getFirstValue () const
| Return a const reference to the first value in the buffer.
const ValueType & | getLastValue () const
| Return a const reference to the last value in the buffer.
void | voxelizeActiveTiles (bool=true)
| No-op.
template<MergePolicy Policy>
void | merge (const LeafNode &)
template<MergePolicy Policy>
void | merge (const LeafNode &other, const ValueType &, const ValueType &)
template<typename OtherType>
void | topologyUnion (const LeafNode< OtherType, Log2Dim > &other, const bool preserveTiles=false)
| Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active.
template<typename OtherType>
void | topologyIntersection (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active.
template<typename OtherType>
void | topologyDifference (const LeafNode< OtherType, Log2Dim > &other, const ValueType &)
| Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode.
template<typename CombineOp>
void | combine (const LeafNode &other, CombineOp &op)
template<typename CombineOp>
void | combine (const ValueType &value, bool valueIsActive, CombineOp &op)
template<typename CombineOp, typename OtherType>
void | combine2 (const LeafNode &other, const OtherType &, bool valueIsActive, CombineOp &)
template<typename CombineOp, typename OtherNodeT>
void | combine2 (const ValueType &, const OtherNodeT &other, bool valueIsActive, CombineOp &)
template<typename CombineOp, typename OtherNodeT>
void | combine2 (const LeafNode &b0, const OtherNodeT &b1, CombineOp &)
void | prune (const ValueType &=zeroVal< ValueType >())
| This function exists only to enable template instantiation.
void | addLeaf (LeafNode *)
template<typename AccessorT>
void | addLeafAndCache (LeafNode *, AccessorT &)
template<typename NodeT>
NodeT * | stealNode (const Coord &, const ValueType &, bool)
template<typename NodeT>
NodeT * | probeNode (const Coord &)
template<typename NodeT>
const NodeT * | probeConstNode (const Coord &) const
template<typename ArrayT>
void | getNodes (ArrayT &) const
template<typename ArrayT>
void | stealNodes (ArrayT &, const ValueType &, bool)
void | addTile (Index level, const Coord &, const ValueType &, bool)
void | addTile (Index offset, const ValueType &, bool)
template<typename AccessorT>
void | addTileAndCache (Index, const Coord &, const ValueType &, bool, AccessorT &)
bool | isConstant (ValueType &firstValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
bool | isConstant (ValueType &minValue, ValueType &maxValue, bool &state, const ValueType &tolerance=zeroVal< ValueType >()) const
ValueType | medianAll (ValueType *tmp=nullptr) const
| Computes the median value of all the active AND inactive voxels in this node.
Index | medianOn (ValueType &value, ValueType *tmp=nullptr) const
| Computes the median value of all the active voxels in this node.
Index | medianOff (ValueType &value, ValueType *tmp=nullptr) const
| Computes the median value of all the inactive voxels in this node.
bool | isInactive () const
| Return `true` if all of this node's values are inactive.
const ValueType & | getValueUnsafe (Index offset) const
| Return the value of the voxel at the given offset.
bool | getValueUnsafe (Index offset, ValueType &value) const
| Return true if the voxel at the given offset is active and set value.
void | setActiveStateUnsafe (Index offset, bool on)
| Set the active state of the voxel at the given offset but don't change its value.
void | setValueOnlyUnsafe (Index offset, const ValueType &value)
| Set the value of the voxel at the given coordinates but don't change its active state.
void | setValueOnUnsafe (Index offset)
| Mark the voxel at the given offset as active but don't change its value.
void | setValueOnUnsafe (Index offset, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active.
void | setValueOffUnsafe (Index offset)
| Mark the voxel at the given offset as inactive but don't change its value.
void | setValueOffUnsafe (Index offset, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active.
bool | isValueMaskOn (Index n) const
bool | isValueMaskOn () const
bool | isValueMaskOff (Index n) const
bool | isValueMaskOff () const
const NodeMaskType & | getValueMask () const
NodeMaskType & | getValueMask ()
const NodeMaskType & | valueMask () const
void | setValueMask (const NodeMaskType &mask)
bool | isChildMaskOn (Index) const
bool | isChildMaskOff (Index) const
bool | isChildMaskOff () const

## Static Public Member Functions
static Index | log2dim ()
| Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3.
static Index | dim ()
| Return the number of voxels in each coordinate dimension.
static Index | size ()
| Return the total number of voxels represented by this LeafNode.
static Index | numValues ()
| Return the total number of voxels represented by this LeafNode.
static Index | getLevel ()
| Return the level of this node, which by definition is zero for LeafNodes.
static void | getNodeLog2Dims (std::vector< Index > &dims)
| Append the Log2Dim of this LeafNode to the specified vector.
static Index | getChildDim ()
| Return the dimension of child nodes of this LeafNode, which is one for voxels.
static Index64 | leafCount ()
| Return the leaf count for this node, which is one.
static Index64 | nonLeafCount ()
| Return the non-leaf count for this node, which is zero.
static Index32 | childCount ()
| Return the child count for this node, which is zero.
static Index64 | onTileCount ()
static Index64 | offTileCount ()
static Index | coordToOffset (const Coord &xyz)
| Return the linear table offset of the given global or local coordinates.
static Coord | offsetToLocalCoord (Index n)
| Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0).
static Index | getValueLevel (const Coord &)
| Return the level (i.e., 0) at which leaf node values reside.
static bool | hasActiveTiles ()
| Return `false` since leaf nodes never contain tiles.
template<typename AccessorT>
static Index | getValueLevelAndCache (const Coord &, AccessorT &)
| Return the LEVEL (=0) at which leaf node values reside.

## Static Public Attributes
static const Index | LOG2DIM
static const Index | TOTAL
static const Index | DIM
static const Index | NUM_VALUES
static const Index | NUM_VOXELS
static const Index | SIZE
static const Index | LEVEL

## Protected Types
using | ValueOn = typename BaseLeaf::ValueOn
using | ValueOff = typename BaseLeaf::ValueOff
using | ValueAll = typename BaseLeaf::ValueAll
using | ChildOn = typename BaseLeaf::ChildOn
using | ChildOff = typename BaseLeaf::ChildOff
using | ChildAll = typename BaseLeaf::ChildAll
using | MaskOnIterator = typename NodeMaskType::OnIterator
using | MaskOffIterator = typename NodeMaskType::OffIterator
using | MaskDenseIterator = typename NodeMaskType::DenseIterator

## Protected Member Functions
void | setValueMask (Index n, bool on)
void | setValueMaskOn (Index n)
void | setValueMaskOff (Index n)
void | skipCompressedValues (bool seekable, std::istream &, bool fromHalf)

## Static Protected Member Functions
static void | evalNodeOrigin (Coord &xyz)
| Compute the origin of the leaf node that contains the voxel with the given coordinates.

## Friends
template<typename, Index>
struct | PointIndexLeafNode
class | tree::IteratorBase< MaskOnIterator, PointIndexLeafNode >
class | tree::IteratorBase< MaskOffIterator, PointIndexLeafNode >
class | tree::IteratorBase< MaskDenseIterator, PointIndexLeafNode >

## Member Typedef Documentation

## ◆ BaseLeaf

template<typename T, Index Log2Dim>

using BaseLeaf = tree::LeafNode<T, Log2Dim>

## ◆ Buffer

template<typename T, Index Log2Dim>

using Buffer = LeafBuffer<ValueType, Log2Dim>
| inherited

## ◆ BuildType

template<typename T, Index Log2Dim>

using BuildType = T
| inherited

## ◆ ChildAll

template<typename T, Index Log2Dim>

using ChildAll = typename BaseLeaf::ChildAll
| protected

## ◆ ChildAllCIter

template<typename T, Index Log2Dim>

using ChildAllCIter

Initial value:
typename BaseLeaf::template DenseIter<
const PointIndexLeafNode, const ValueType, ChildAll>
openvdb::v13_0::points::PointDataLeafNode::ChildAll
typename BaseLeaf::ChildAll ChildAll
Definition PointDataGrid.h:608
openvdb::v13_0::points::PointDataLeafNode::ValueType
T ValueType
Definition PointDataGrid.h:246
openvdb::v13_0::tools::PointIndexLeafNode::PointIndexLeafNode
friend struct PointIndexLeafNode
Definition PointIndexGrid.h:1579
openvdb::v13_0::tree::LeafNode::DenseIter
Definition LeafNode.h:291

## ◆ ChildAllIter

template<typename T, Index Log2Dim>

using ChildAllIter

Initial value:
typename BaseLeaf::template DenseIter<
PointIndexLeafNode, ValueType, ChildAll>

## ◆ ChildOff

template<typename T, Index Log2Dim>

using ChildOff = typename BaseLeaf::ChildOff
| protected

## ◆ ChildOffCIter

template<typename T, Index Log2Dim>

using ChildOffCIter

Initial value:
typename BaseLeaf::template ChildIter<
MaskOffIterator, const PointIndexLeafNode, ChildOff>
openvdb::v13_0::points::PointDataLeafNode::ChildOff
typename BaseLeaf::ChildOff ChildOff
Definition PointDataGrid.h:607
openvdb::v13_0::points::PointDataLeafNode::MaskOffIterator
typename NodeMaskType::OffIterator MaskOffIterator
Definition PointDataGrid.h:611
openvdb::v13_0::tree::LeafNode::ChildIter
Leaf nodes have no children, so their child iterators have no get/set accessors.
Definition LeafNode.h:282

## ◆ ChildOffIter

template<typename T, Index Log2Dim>

using ChildOffIter

Initial value:
typename BaseLeaf::template ChildIter<
MaskOffIterator, PointIndexLeafNode, ChildOff>

## ◆ ChildOn

template<typename T, Index Log2Dim>

using ChildOn = typename BaseLeaf::ChildOn
| protected

## ◆ ChildOnCIter

template<typename T, Index Log2Dim>

using ChildOnCIter

Initial value:
typename BaseLeaf::template ChildIter<
MaskOnIterator, const PointIndexLeafNode, ChildOn>
openvdb::v13_0::points::PointDataLeafNode::ChildOn
typename BaseLeaf::ChildOn ChildOn
Definition PointDataGrid.h:606
openvdb::v13_0::points::PointDataLeafNode::MaskOnIterator
typename NodeMaskType::OnIterator MaskOnIterator
Definition PointDataGrid.h:610

## ◆ ChildOnIter

template<typename T, Index Log2Dim>

using ChildOnIter

Initial value:
typename BaseLeaf::template ChildIter<
MaskOnIterator, PointIndexLeafNode, ChildOn>

## ◆ IndexArray

template<typename T, Index Log2Dim>

using IndexArray = std::vector<ValueType>

## ◆ LeafNodeType

template<typename T, Index Log2Dim>

using LeafNodeType = PointIndexLeafNode<T, Log2Dim>

## ◆ MaskDenseIterator

template<typename T, Index Log2Dim>

using MaskDenseIterator = typename NodeMaskType::DenseIterator
| protected

## ◆ MaskOffIterator

template<typename T, Index Log2Dim>

using MaskOffIterator = typename NodeMaskType::OffIterator
| protected

## ◆ MaskOnIterator

template<typename T, Index Log2Dim>

using MaskOnIterator = typename NodeMaskType::OnIterator
| protected

## ◆ NodeMaskType

template<typename T, Index Log2Dim>

using NodeMaskType = util::NodeMask<Log2Dim>

## ◆ Ptr

template<typename T, Index Log2Dim>

using Ptr = SharedPtr<PointIndexLeafNode>

## ◆ ValueAll

template<typename T, Index Log2Dim>

using ValueAll = typename BaseLeaf::ValueAll
| protected

## ◆ ValueAllCIter

template<typename T, Index Log2Dim>

using ValueAllCIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskDenseIterator,const PointIndexLeafNode,const ValueType, ValueAll>
openvdb::v13_0::points::PointDataLeafNode::ValueAll
typename BaseLeaf::ValueAll ValueAll
Definition PointDataGrid.h:599
openvdb::v13_0::points::PointDataLeafNode::MaskDenseIterator
typename NodeMaskType::DenseIterator MaskDenseIterator
Definition PointDataGrid.h:612
openvdb::v13_0::tree::LeafNode::ValueIter
Definition LeafNode.h:221

## ◆ ValueAllIter

template<typename T, Index Log2Dim>

using ValueAllIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskDenseIterator, PointIndexLeafNode, const ValueType, ValueAll>

## ◆ ValueOff

template<typename T, Index Log2Dim>

using ValueOff = typename BaseLeaf::ValueOff
| protected

## ◆ ValueOffCIter

template<typename T, Index Log2Dim>

using ValueOffCIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskOffIterator,const PointIndexLeafNode,const ValueType, ValueOff>
openvdb::v13_0::points::PointDataLeafNode::ValueOff
typename BaseLeaf::ValueOff ValueOff
Definition PointDataGrid.h:598

## ◆ ValueOffIter

template<typename T, Index Log2Dim>

using ValueOffIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskOffIterator, PointIndexLeafNode, const ValueType, ValueOff>

## ◆ ValueOn

template<typename T, Index Log2Dim>

using ValueOn = typename BaseLeaf::ValueOn
| protected

## ◆ ValueOnCIter

template<typename T, Index Log2Dim>

using ValueOnCIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskOnIterator, const PointIndexLeafNode, const ValueType, ValueOn>
openvdb::v13_0::points::PointDataLeafNode::ValueOn
typename BaseLeaf::ValueOn ValueOn
Definition PointDataGrid.h:597

## ◆ ValueOnIter

template<typename T, Index Log2Dim>

using ValueOnIter

Initial value:
typename BaseLeaf::template ValueIter<
MaskOnIterator, PointIndexLeafNode, const ValueType, ValueOn>

## ◆ ValueType

template<typename T, Index Log2Dim>

using ValueType = T

## Constructor & Destructor Documentation

## ◆ PointIndexLeafNode() [1/4]

template<typename T, Index Log2Dim>

PointIndexLeafNode | ( |  | ) |
| inline

Default constructor.

## ◆ PointIndexLeafNode() [2/4]

template<typename T, Index Log2Dim>

PointIndexLeafNode | ( | const Coord & | coords,
|  | const T & | value = zeroVal<T>(),
|  | bool | active = false )
| inlineexplicit

## ◆ PointIndexLeafNode() [3/4]

template<typename T, Index Log2Dim>

PointIndexLeafNode | ( | PartialCreate | ,
|  | const Coord & | coords,
|  | const T & | value = zeroVal<T>(),
|  | bool | active = false )
| inline

## ◆ PointIndexLeafNode() [4/4]

template<typename T, Index Log2Dim>

PointIndexLeafNode | ( | const PointIndexLeafNode< T, Log2Dim > & | rhs | ) |
| inline

Deep copy constructor.

## Member Function Documentation

## ◆ addLeaf() [1/2]

template<typename T, Index Log2Dim>

void addLeaf | ( | PointIndexLeafNode< T, Log2Dim > * |  | ) |
| inline

## ◆ addLeaf() [2/2]

template<typename T, Index Log2Dim>

void addLeaf | ( | LeafNode< T, Log2Dim > * |  | ) |
| inlineinherited

## ◆ addLeafAndCache() [1/2]

template<typename T, Index Log2Dim>
template<typename AccessorT>

void addLeafAndCache | ( | PointIndexLeafNode< T, Log2Dim > * | ,
|  | AccessorT & | )
| inline

## ◆ addLeafAndCache() [2/2]

template<typename T, Index Log2Dim>
template<typename AccessorT>

void addLeafAndCache | ( | LeafNode< T, Log2Dim > * | ,
|  | AccessorT & | )
| inlineinherited

## ◆ addTile() [1/2]

template<typename T, Index Log2Dim>

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active )
| inlineinherited

## ◆ addTile() [2/2]

template<typename T, Index Log2Dim>

void addTile | ( | Index | offset,
|  | const ValueType & | val,
|  | bool | active )
| inlineinherited

## ◆ addTileAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

void addTileAndCache | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | val,
|  | bool | active,
|  | AccessorT & | )
| inlineinherited

## ◆ allocate()

template<typename T, Index Log2Dim>

bool allocate | ( |  | ) |
| inlineinherited

Allocate memory for this node's buffer if it has not already been allocated.

## ◆ assertNonmodifiable()

template<typename T, Index Log2Dim>

void assertNonmodifiable | ( |  | ) |
| inline

## ◆ beginChildAll() [1/2]

template<typename T, Index Log2Dim>

ChildAllIter beginChildAll | ( |  | ) |
| inline

## ◆ beginChildAll() [2/2]

template<typename T, Index Log2Dim>

ChildAllCIter beginChildAll | ( |  | ) | const
| inline

## ◆ beginChildOff() [1/2]

template<typename T, Index Log2Dim>

ChildOffIter beginChildOff | ( |  | ) |
| inline

## ◆ beginChildOff() [2/2]

template<typename T, Index Log2Dim>

ChildOffCIter beginChildOff | ( |  | ) | const
| inline

## ◆ beginChildOn() [1/2]

template<typename T, Index Log2Dim>

ChildOnIter beginChildOn | ( |  | ) |
| inline

## ◆ beginChildOn() [2/2]

template<typename T, Index Log2Dim>

ChildOnCIter beginChildOn | ( |  | ) | const
| inline

## ◆ beginValueAll() [1/2]

template<typename T, Index Log2Dim>

ValueAllIter beginValueAll | ( |  | ) |
| inline

## ◆ beginValueAll() [2/2]

template<typename T, Index Log2Dim>

ValueAllCIter beginValueAll | ( |  | ) | const
| inline

## ◆ beginValueOff() [1/2]

template<typename T, Index Log2Dim>

ValueOffIter beginValueOff | ( |  | ) |
| inline

## ◆ beginValueOff() [2/2]

template<typename T, Index Log2Dim>

ValueOffCIter beginValueOff | ( |  | ) | const
| inline

## ◆ beginValueOn() [1/2]

template<typename T, Index Log2Dim>

ValueOnIter beginValueOn | ( |  | ) |
| inline

## ◆ beginValueOn() [2/2]

template<typename T, Index Log2Dim>

ValueOnCIter beginValueOn | ( |  | ) | const
| inline

## ◆ buffer() [1/2]

template<typename T, Index Log2Dim>

Buffer & buffer | ( |  | ) |
| inlineinherited

## ◆ buffer() [2/2]

template<typename T, Index Log2Dim>

const Buffer & buffer | ( |  | ) | const
| inlineinherited

## ◆ cbeginChildAll()

template<typename T, Index Log2Dim>

ChildAllCIter cbeginChildAll | ( |  | ) | const
| inline

## ◆ cbeginChildOff()

template<typename T, Index Log2Dim>

ChildOffCIter cbeginChildOff | ( |  | ) | const
| inline

## ◆ cbeginChildOn()

template<typename T, Index Log2Dim>

ChildOnCIter cbeginChildOn | ( |  | ) | const
| inline

## ◆ cbeginValueAll()

template<typename T, Index Log2Dim>

ValueAllCIter cbeginValueAll | ( |  | ) | const
| inline

## ◆ cbeginValueOff()

template<typename T, Index Log2Dim>

ValueOffCIter cbeginValueOff | ( |  | ) | const
| inline

## ◆ cbeginValueOn()

template<typename T, Index Log2Dim>

ValueOnCIter cbeginValueOn | ( |  | ) | const
| inline

## ◆ cendChildAll()

template<typename T, Index Log2Dim>

ChildAllCIter cendChildAll | ( |  | ) | const
| inline

## ◆ cendChildOff()

template<typename T, Index Log2Dim>

ChildOffCIter cendChildOff | ( |  | ) | const
| inline

## ◆ cendChildOn()

template<typename T, Index Log2Dim>

ChildOnCIter cendChildOn | ( |  | ) | const
| inline

## ◆ cendValueAll()

template<typename T, Index Log2Dim>

ValueAllCIter cendValueAll | ( |  | ) | const
| inline

## ◆ cendValueOff()

template<typename T, Index Log2Dim>

ValueOffCIter cendValueOff | ( |  | ) | const
| inline

## ◆ cendValueOn()

template<typename T, Index Log2Dim>

ValueOnCIter cendValueOn | ( |  | ) | const
| inline

## ◆ childCount()

template<typename T, Index Log2Dim>

Index32 childCount | ( |  | ) |
| inlinestaticinherited

Return the child count for this node, which is zero.

## ◆ clip()

template<typename T, Index Log2Dim>

void clip | ( | const CoordBBox & | ,
|  | const ValueType & | )
| inline

## ◆ combine() [1/2]

template<typename T, Index Log2Dim>
template<typename CombineOp>

void combine | ( | const LeafNode< T, Log2Dim > & | other,
|  | CombineOp & | op )
| inlineinherited

## ◆ combine() [2/2]

template<typename T, Index Log2Dim>
template<typename CombineOp>

void combine | ( | const ValueType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op )
| inlineinherited

## ◆ combine2() [1/3]

template<typename T, Index Log2Dim>
template<typename CombineOp, typename OtherNodeT>

void combine2 | ( | const LeafNode< T, Log2Dim > & | b0,
|  | const OtherNodeT & | b1,
|  | CombineOp & | op )
| inlineinherited

## ◆ combine2() [2/3]

template<typename T, Index Log2Dim>
template<typename CombineOp, typename OtherType>

void combine2 | ( | const LeafNode< T, Log2Dim > & | other,
|  | const OtherType & | value,
|  | bool | valueIsActive,
|  | CombineOp & | op )
| inlineinherited

## ◆ combine2() [3/3]

template<typename T, Index Log2Dim>
template<typename CombineOp, typename OtherNodeT>

void combine2 | ( | const ValueType & | value,
|  | const OtherNodeT & | other,
|  | bool | valueIsActive,
|  | CombineOp & | op )
| inlineinherited

## ◆ coordToOffset()

template<typename T, Index Log2Dim>

Index coordToOffset | ( | const Coord & | xyz | ) |
| inlinestaticinherited

Return the linear table offset of the given global or local coordinates.

## ◆ copyFromDense()

template<typename T, Index Log2Dim>
template<typename DenseT>

void copyFromDense | ( | const CoordBBox & | bbox,
|  | const DenseT & | dense,
|  | const ValueType & | background,
|  | const ValueType & | tolerance )
| inlineinherited

Copy from a dense grid into this node the values of the voxels that lie within a given bounding box.

Only values that are different (by more than the given tolerance) from the background value will be active. Other values are inactive and truncated to the background value.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into this node
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)
  background | background value of the tree that this node belongs to
  tolerance | tolerance within which a value equals the background value

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyFromDense in tools/Dense.h instead of calling this method directly.

## ◆ copyToDense()

template<typename T, Index Log2Dim>
template<typename DenseT>

void copyToDense | ( | const CoordBBox & | bbox,
|  | DenseT & | dense ) const
| inlineinherited

Copy into a dense grid the values of the voxels that lie within a given bounding box.

Parameters

  bbox | inclusive bounding box of the voxels to be copied into the dense grid
  dense | dense grid with a stride in z of one (see tools::Dense in tools/Dense.h for the required API)

Note
  bbox is assumed to be identical to or contained in the coordinate domains of both the dense grid and this node, i.e., no bounds checking is performed.
  Consider using tools::CopyToDense in tools/Dense.h instead of calling this method directly.

## ◆ denseFill()

template<typename T, Index Log2Dim>

void denseFill | ( | const CoordBBox & | bbox,
|  | const ValueType & | value,
|  | bool | active = true )
| inlineinherited

Set all voxels within an axis-aligned box to the specified value and active state.

## ◆ dim()

template<typename T, Index Log2Dim>

Index dim | ( |  | ) |
| inlinestaticinherited

Return the number of voxels in each coordinate dimension.

## ◆ endChildAll() [1/2]

template<typename T, Index Log2Dim>

ChildAllIter endChildAll | ( |  | ) |
| inline

## ◆ endChildAll() [2/2]

template<typename T, Index Log2Dim>

ChildAllCIter endChildAll | ( |  | ) | const
| inline

## ◆ endChildOff() [1/2]

template<typename T, Index Log2Dim>

ChildOffIter endChildOff | ( |  | ) |
| inline

## ◆ endChildOff() [2/2]

template<typename T, Index Log2Dim>

ChildOffCIter endChildOff | ( |  | ) | const
| inline

## ◆ endChildOn() [1/2]

template<typename T, Index Log2Dim>

ChildOnIter endChildOn | ( |  | ) |
| inline

## ◆ endChildOn() [2/2]

template<typename T, Index Log2Dim>

ChildOnCIter endChildOn | ( |  | ) | const
| inline

## ◆ endValueAll() [1/2]

template<typename T, Index Log2Dim>

ValueAllIter endValueAll | ( |  | ) |
| inline

## ◆ endValueAll() [2/2]

template<typename T, Index Log2Dim>

ValueAllCIter endValueAll | ( |  | ) | const
| inline

## ◆ endValueOff() [1/2]

template<typename T, Index Log2Dim>

ValueOffIter endValueOff | ( |  | ) |
| inline

## ◆ endValueOff() [2/2]

template<typename T, Index Log2Dim>

ValueOffCIter endValueOff | ( |  | ) | const
| inline

## ◆ endValueOn() [1/2]

template<typename T, Index Log2Dim>

ValueOnIter endValueOn | ( |  | ) |
| inline

## ◆ endValueOn() [2/2]

template<typename T, Index Log2Dim>

ValueOnCIter endValueOn | ( |  | ) | const
| inline

## ◆ evalActiveBoundingBox()

template<typename T, Index Log2Dim>

void evalActiveBoundingBox | ( | CoordBBox & | bbox,
|  | bool | visitVoxels = true ) const
| inlineinherited

Expand the given bounding box so that it includes this leaf node's active voxels. If visitVoxels is false this LeafNode will be approximated as dense, i.e. with all voxels active. Else the individual active voxels are visited to produce a tight bbox.

## ◆ evalNodeOrigin()

template<typename T, Index Log2Dim>

void evalNodeOrigin | ( | Coord & | xyz | ) |
| inlinestaticprotectedinherited

Compute the origin of the leaf node that contains the voxel with the given coordinates.

## ◆ fill() [1/3]

template<typename T, Index Log2Dim>

void fill | ( | const CoordBBox & | ,
|  | const ValueType & | ,
|  | bool | )
| inline

## ◆ fill() [2/3]

template<typename T, Index Log2Dim>

void fill | ( | const ValueType & |  | ) |
| inline

## ◆ fill() [3/3]

template<typename T, Index Log2Dim>

void fill | ( | const ValueType & | ,
|  | bool | )
| inline

## ◆ getChildDim()

template<typename T, Index Log2Dim>

Index getChildDim | ( |  | ) |
| inlinestaticinherited

Return the dimension of child nodes of this LeafNode, which is one for voxels.

## ◆ getFirstValue()

template<typename T, Index Log2Dim>

const ValueType & getFirstValue | ( |  | ) | const
| inlineinherited

Return a const reference to the first value in the buffer.

Note
  Though it is potentially risky you can convert this to a non-const pointer by means of const_case<ValueType*>&.

## ◆ getIndices() [1/2]

template<typename T, Index Log2Dim>

bool getIndices | ( | const Coord & | ijk,
|  | const ValueType *& | begin,
|  | const ValueType *& | end ) const
| inline

## ◆ getIndices() [2/2]

template<typename T, Index Log2Dim>

bool getIndices | ( | Index | offset,
|  | const ValueType *& | begin,
|  | const ValueType *& | end ) const
| inline

## ◆ getLastValue()

template<typename T, Index Log2Dim>

const ValueType & getLastValue | ( |  | ) | const
| inlineinherited

Return a const reference to the last value in the buffer.

## ◆ getLevel()

template<typename T, Index Log2Dim>

Index getLevel | ( |  | ) |
| inlinestaticinherited

Return the level of this node, which by definition is zero for LeafNodes.

## ◆ getNodeBoundingBox()

template<typename T, Index Log2Dim>

CoordBBox getNodeBoundingBox | ( |  | ) | const
| inlineinherited

Return the bounding box of this node, i.e., the full index space spanned by this leaf node.

## ◆ getNodeLog2Dims()

template<typename T, Index Log2Dim>

void getNodeLog2Dims | ( | std::vector< Index > & | dims | ) |
| inlinestaticinherited

Append the Log2Dim of this LeafNode to the specified vector.

## ◆ getNodes()

template<typename T, Index Log2Dim>
template<typename ArrayT>

void getNodes | ( | ArrayT & |  | ) | const
| inlineinherited

## ◆ getOrigin() [1/2]

template<typename T, Index Log2Dim>

void getOrigin | ( | Coord & | origin | ) | const
| inlineinherited

## ◆ getOrigin() [2/2]

template<typename T, Index Log2Dim>

void getOrigin | ( | Int32 & | x,
|  | Int32 & | y,
|  | Int32 & | z ) const
| inlineinherited

## ◆ getValue() [1/3]

template<typename ValueT, Index Log2Dim>

const ValueT & getValue | ( | const Coord & | xyz | ) | const
| inlineinherited

Return the value of the voxel at the given coordinates.

## ◆ getValue() [2/3]

template<typename T, Index Log2Dim>
template<typename AccessorT>

const ValueType & getValue | ( | const Coord & | xyz,
|  | bool & | state,
|  | int & | level,
|  | AccessorT & | ) const
| inlineinherited

Return the value of the voxel at the given coordinates and return its active state and level (i.e., 0) in state and level.

Note
  Used internally by ValueAccessor.

## ◆ getValue() [3/3]

template<typename ValueT, Index Log2Dim>

const ValueT & getValue | ( | Index | offset | ) | const
| inlineinherited

Return the value of the voxel at the given linear offset.

## ◆ getValueAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

const ValueType & getValueAndCache | ( | const Coord & | xyz,
|  | AccessorT & | ) const
| inlineinherited

Return the value of the voxel at the given coordinates.

Note
  Used internally by ValueAccessor.

## ◆ getValueLevel()

template<typename T, Index Log2Dim>

Index getValueLevel | ( | const Coord & |  | ) |
| inlinestaticinherited

Return the level (i.e., 0) at which leaf node values reside.

## ◆ getValueLevelAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

Index getValueLevelAndCache | ( | const Coord & | ,
|  | AccessorT & | )
| inlinestaticinherited

Return the LEVEL (=0) at which leaf node values reside.

Note
  Used internally by ValueAccessor (note last argument is a dummy).

## ◆ getValueMask() [1/2]

template<typename T, Index Log2Dim>

NodeMaskType & getValueMask | ( |  | ) |
| inlineinherited

## ◆ getValueMask() [2/2]

template<typename T, Index Log2Dim>

const NodeMaskType & getValueMask | ( |  | ) | const
| inlineinherited

## ◆ getValueUnsafe() [1/2]

template<typename T, Index Log2Dim>

const ValueType & getValueUnsafe | ( | Index | offset | ) | const
| inlineinherited

Return the value of the voxel at the given offset.

## ◆ getValueUnsafe() [2/2]

template<typename T, Index Log2Dim>

bool getValueUnsafe | ( | Index | offset,
|  | ValueType & | value ) const
| inlineinherited

Return true if the voxel at the given offset is active and set value.

## ◆ hasActiveTiles()

template<typename T, Index Log2Dim>

bool hasActiveTiles | ( |  | ) |
| inlinestaticinherited

Return `false` since leaf nodes never contain tiles.

## ◆ hasSameTopology() [1/2]

template<typename T, Index Log2Dim>
template<typename OtherType, Index OtherLog2Dim>

bool hasSameTopology | ( | const PointIndexLeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inline

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

## ◆ hasSameTopology() [2/2]

template<typename T, Index Log2Dim>
template<typename OtherType, Index OtherLog2Dim>

bool hasSameTopology | ( | const LeafNode< OtherType, OtherLog2Dim > * | other | ) | const
| inlineinherited

Return `true` if the given node (which may have a different `ValueType` than this node) has the same active value topology as this node.

## ◆ indices() [1/2]

template<typename T, Index Log2Dim>

IndexArray & indices | ( |  | ) |
| inline

## ◆ indices() [2/2]

template<typename T, Index Log2Dim>

const IndexArray & indices | ( |  | ) | const
| inline

## ◆ isAllocated()

template<typename T, Index Log2Dim>

bool isAllocated | ( |  | ) | const
| inlineinherited

Return `true` if memory for this node's buffer has been allocated.

## ◆ isChildMaskOff() [1/2]

template<typename T, Index Log2Dim>

bool isChildMaskOff | ( |  | ) | const
| inlineinherited

## ◆ isChildMaskOff() [2/2]

template<typename T, Index Log2Dim>

bool isChildMaskOff | ( | Index |  | ) | const
| inlineinherited

## ◆ isChildMaskOn()

template<typename T, Index Log2Dim>

bool isChildMaskOn | ( | Index |  | ) | const
| inlineinherited

## ◆ isConstant() [1/2]

template<typename T, Index Log2Dim>

bool isConstant | ( | ValueType & | firstValue,
|  | bool & | state,
|  | const ValueType & | tolerance = zeroVal<ValueType>() ) const
| inlineinherited

Return `true` if all of this node's values have the same active state and are in the range this->getFirstValue() +/- tolerance.

Parameters

  firstValue | Is updated with the first value of this leaf node.
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximately equal to the for value.

## ◆ isConstant() [2/2]

template<typename T, Index Log2Dim>

bool isConstant | ( | ValueType & | minValue,
|  | ValueType & | maxValue,
|  | bool & | state,
|  | const ValueType & | tolerance = zeroVal<ValueType>() ) const
| inlineinherited

Return `true` if all of this node's values have the same active state and the range (maxValue - minValue) < tolerance.

Parameters

  minValue | Is updated with the minimum of all values IF method returns `true`. Else the value is undefined!
  maxValue | Is updated with the maximum of all values IF method returns `true`. Else the value is undefined!
  state | Is updated with the state of all values IF method returns `true`. Else the value is undefined!
  tolerance | The tolerance used to determine if values are approximately constant.

## ◆ isDense()

template<typename T, Index Log2Dim>

bool isDense | ( |  | ) | const
| inlineinherited

Return `true` if this node contains only active voxels.

## ◆ isEmpty() [1/2]

template<typename T, Index Log2Dim>

bool isEmpty | ( | const CoordBBox & | bbox | ) | const
| inline

## ◆ isEmpty() [2/2]

template<typename T, Index Log2Dim>

bool isEmpty | ( |  | ) | const
| inlineinherited

Return `true` if this node has no active voxels.

## ◆ isInactive()

template<typename T, Index Log2Dim>

bool isInactive | ( |  | ) | const
| inlineinherited

Return `true` if all of this node's values are inactive.

## ◆ isValueMaskOff() [1/2]

template<typename T, Index Log2Dim>

bool isValueMaskOff | ( |  | ) | const
| inlineinherited

## ◆ isValueMaskOff() [2/2]

template<typename T, Index Log2Dim>

bool isValueMaskOff | ( | Index | n | ) | const
| inlineinherited

## ◆ isValueMaskOn() [1/2]

template<typename T, Index Log2Dim>

bool isValueMaskOn | ( |  | ) | const
| inlineinherited

## ◆ isValueMaskOn() [2/2]

template<typename T, Index Log2Dim>

bool isValueMaskOn | ( | Index | n | ) | const
| inlineinherited

## ◆ isValueOff() [1/2]

template<typename T, Index Log2Dim>

bool isValueOff | ( | const Coord & | xyz | ) | const
| inlineinherited

Return `true` if the voxel at the given coordinates is inactive.

## ◆ isValueOff() [2/2]

template<typename T, Index Log2Dim>

bool isValueOff | ( | Index | offset | ) | const
| inlineinherited

Return `true` if the voxel at the given offset is inactive.

## ◆ isValueOn() [1/2]

template<typename T, Index Log2Dim>

bool isValueOn | ( | const Coord & | xyz | ) | const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

## ◆ isValueOn() [2/2]

template<typename T, Index Log2Dim>

bool isValueOn | ( | Index | offset | ) | const
| inlineinherited

Return `true` if the voxel at the given offset is active.

## ◆ isValueOnAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

bool isValueOnAndCache | ( | const Coord & | xyz,
|  | AccessorT & | ) const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

Note
  Used internally by ValueAccessor.

## ◆ leafCount()

template<typename T, Index Log2Dim>

Index64 leafCount | ( |  | ) |
| inlinestaticinherited

Return the leaf count for this node, which is one.

## ◆ log2dim()

template<typename T, Index Log2Dim>

Index log2dim | ( |  | ) |
| inlinestaticinherited

Return log2 of the dimension of this LeafNode, e.g. 3 if dimensions are 8^3.

## ◆ medianAll()

template<typename T, Index Log2Dim>

T medianAll | ( | ValueType * | tmp = nullptr | ) | const
| inlineinherited

Computes the median value of all the active AND inactive voxels in this node.

Returns
  The median value of all values in this node.

Parameters

  tmp | Optional temporary storage that can hold at least NUM_VALUES values Use of this temporary storage can improve performance when this method is called multiple times.

Note
  If tmp = this->buffer().data() then the median value is computed very efficiently (in place) but the voxel values in this node are re-shuffled!

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold NUM_VALUES elements of type ValueType.

## ◆ medianOff()

template<typename T, Index Log2Dim>

Index medianOff | ( | ValueType & | value,
|  | ValueType * | tmp = nullptr ) const
| inlineinherited

Computes the median value of all the inactive voxels in this node.

Returns
  The number of inactive voxels.

Parameters

  value | If the return value is non zero value is updated with the median value.
  tmp | Optional temporary storage that can hold at least as many values as there are inactive voxels in this node. Use of this temporary storage can improve performance when this method is called multiple times.

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold the number of inactive voxels of type ValueType.

## ◆ medianOn()

template<typename T, Index Log2Dim>

Index medianOn | ( | ValueType & | value,
|  | ValueType * | tmp = nullptr ) const
| inlineinherited

Computes the median value of all the active voxels in this node.

Returns
  The number of active voxels.

Parameters

  value | If the return value is non zero value is updated with the median value.
  tmp | Optional temporary storage that can hold at least as many values as there are active voxels in this node. Use of this temporary storage can improve performance when this method is called multiple times.

Warning
  If tmp != nullptr then it is the responsibility of the client code that it points to enough memory to hold the number of active voxels of type ValueType.

## ◆ memUsage()

template<typename T, Index Log2Dim>

Index64 memUsage | ( |  | ) | const
| inline

## ◆ memUsageIfLoaded()

template<typename T, Index Log2Dim>

Index64 memUsageIfLoaded | ( |  | ) | const
| inline

## ◆ merge() [1/5]

template<typename T, Index Log2Dim>
template<MergePolicy Policy>

void merge | ( | const PointIndexLeafNode< T, Log2Dim > & | other,
|  | const ValueType & | ,
|  | const ValueType & | )
| inline

## ◆ merge() [2/5]

template<typename T, Index Log2Dim>
template<MergePolicy Policy>

void merge | ( | const PointIndexLeafNode< T, Log2Dim > & | rhs | ) |
| inline

## ◆ merge() [3/5]

template<typename T, Index Log2Dim>
template<MergePolicy Policy>

void merge | ( | const ValueType & | tileValue,
|  | bool | tileActive )
| inline

## ◆ merge() [4/5]

template<typename T, Index Log2Dim>
template<MergePolicy Policy>

void merge | ( | const LeafNode< T, Log2Dim > & | other | ) |
| inlineinherited

## ◆ merge() [5/5]

template<typename T, Index Log2Dim>
template<MergePolicy Policy>

void merge | ( | const LeafNode< T, Log2Dim > & | other,
|  | const ValueType & | ,
|  | const ValueType & | )
| inlineinherited

## ◆ modifyValue() [1/2]

template<typename T, Index Log2Dim>
template<typename ModifyOp>

void modifyValue | ( | const Coord & | ,
|  | const ModifyOp & | )
| inline

## ◆ modifyValue() [2/2]

template<typename T, Index Log2Dim>
template<typename ModifyOp>

void modifyValue | ( | Index | ,
|  | const ModifyOp & | )
| inline

## ◆ modifyValueAndActiveState()

template<typename T, Index Log2Dim>
template<typename ModifyOp>

void modifyValueAndActiveState | ( | const Coord & | ,
|  | const ModifyOp & | )
| inline

## ◆ modifyValueAndActiveStateAndCache()

template<typename T, Index Log2Dim>
template<typename ModifyOp, typename AccessorT>

void modifyValueAndActiveStateAndCache | ( | const Coord & | ,
|  | const ModifyOp & | ,
|  | AccessorT & | )
| inline

## ◆ modifyValueAndCache()

template<typename T, Index Log2Dim>
template<typename ModifyOp, typename AccessorT>

void modifyValueAndCache | ( | const Coord & | xyz,
|  | const ModifyOp & | op,
|  | AccessorT & | )
| inlineinherited

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

Note
  Used internally by ValueAccessor.

## ◆ negate()

template<typename T, Index Log2Dim>

void negate | ( |  | ) |
| inline

## ◆ nodeCount() [1/2]

template<typename T, Index Log2Dim>

void nodeCount | ( | std::vector< Index32 > & |  | ) | const
| inlineinherited

Deprecated
  "Use input type std::vector<Index64> for nodeCount."

## ◆ nodeCount() [2/2]

template<typename T, Index Log2Dim>

void nodeCount | ( | std::vector< Index64 > & |  | ) | const
| inlineinherited

no-op

## ◆ nonLeafCount()

template<typename T, Index Log2Dim>

Index64 nonLeafCount | ( |  | ) |
| inlinestaticinherited

Return the non-leaf count for this node, which is zero.

## ◆ numValues()

template<typename T, Index Log2Dim>

Index numValues | ( |  | ) |
| inlinestaticinherited

Return the total number of voxels represented by this LeafNode.

## ◆ offLeafVoxelCount()

template<typename T, Index Log2Dim>

Index64 offLeafVoxelCount | ( |  | ) | const
| inlineinherited

## ◆ offsetToGlobalCoord()

template<typename T, Index Log2Dim>

Coord offsetToGlobalCoord | ( | Index | n | ) | const
| inlineinherited

Return the global coordinates for a linear table offset.

## ◆ offsetToLocalCoord()

template<typename T, Index Log2Dim>

Coord offsetToLocalCoord | ( | Index | n | ) |
| inlinestaticinherited

Return the local coordinates for a linear table offset, where offset 0 has coordinates (0, 0, 0).

## ◆ offTileCount()

template<typename T, Index Log2Dim>

Index64 offTileCount | ( |  | ) |
| inlinestaticinherited

## ◆ offVoxelCount()

template<typename T, Index Log2Dim>

Index64 offVoxelCount | ( |  | ) | const
| inlineinherited

Return the number of voxels marked Off.

## ◆ onLeafVoxelCount()

template<typename T, Index Log2Dim>

Index64 onLeafVoxelCount | ( |  | ) | const
| inlineinherited

## ◆ onTileCount()

template<typename T, Index Log2Dim>

Index64 onTileCount | ( |  | ) |
| inlinestaticinherited

## ◆ onVoxelCount()

template<typename T, Index Log2Dim>

Index64 onVoxelCount | ( |  | ) | const
| inlineinherited

Return the number of voxels marked On.

## ◆ operator!=() [1/2]

template<typename T, Index Log2Dim>

bool operator!= | ( | const PointIndexLeafNode< T, Log2Dim > & | other | ) | const
| inline

## ◆ operator!=() [2/2]

template<typename T, Index Log2Dim>

bool operator!= | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inlineinherited

## ◆ operator==() [1/2]

template<typename T, Index Log2Dim>

bool operator== | ( | const PointIndexLeafNode< T, Log2Dim > & | other | ) | const
| inline

Check for buffer, state and origin equivalence.

## ◆ operator==() [2/2]

template<typename T, Index Log2Dim>

bool operator== | ( | const LeafNode< T, Log2Dim > & | other | ) | const
| inlineinherited

Check for buffer, state and origin equivalence.

## ◆ origin()

template<typename T, Index Log2Dim>

const Coord & origin | ( |  | ) | const
| inlineinherited

Return the grid index coordinates of this node's local origin.

## ◆ probeConstLeaf()

template<typename T, Index Log2Dim>

const PointIndexLeafNode * probeConstLeaf | ( | const Coord & |  | ) | const
| inline

Return a const pointer to this node.

## ◆ probeConstLeafAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

const PointIndexLeafNode * probeConstLeafAndCache | ( | const Coord & | ,
|  | AccessorT & | ) const
| inline

## ◆ probeConstNode()

template<typename T, Index Log2Dim>
template<typename NodeT>

const NodeT * probeConstNode | ( | const Coord & |  | ) | const
| inlineinherited

## ◆ probeConstNodeAndCache()

template<typename T, Index Log2Dim>
template<typename NodeT, typename AccessorT>

const NodeT * probeConstNodeAndCache | ( | const Coord & | ,
|  | AccessorT & | ) const
| inline

## ◆ probeLeaf() [1/2]

template<typename T, Index Log2Dim>

PointIndexLeafNode * probeLeaf | ( | const Coord & |  | ) |
| inline

## ◆ probeLeaf() [2/2]

template<typename T, Index Log2Dim>

const PointIndexLeafNode * probeLeaf | ( | const Coord & |  | ) | const
| inline

## ◆ probeLeafAndCache() [1/2]

template<typename T, Index Log2Dim>
template<typename AccessorT>

PointIndexLeafNode * probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & | )
| inline

## ◆ probeLeafAndCache() [2/2]

template<typename T, Index Log2Dim>
template<typename AccessorT>

const PointIndexLeafNode * probeLeafAndCache | ( | const Coord & | ,
|  | AccessorT & | ) const
| inline

## ◆ probeNode()

template<typename T, Index Log2Dim>
template<typename NodeT>

NodeT * probeNode | ( | const Coord & |  | ) |
| inlineinherited

## ◆ probeNodeAndCache()

template<typename T, Index Log2Dim>
template<typename NodeT, typename AccessorT>

NodeT * probeNodeAndCache | ( | const Coord & | ,
|  | AccessorT & | )
| inline

## ◆ probeValue() [1/2]

template<typename T, Index Log2Dim>

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | val ) const
| inlineinherited

Return `true` if the voxel at the given coordinates is active.

Parameters

  | xyz | the coordinates of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

## ◆ probeValue() [2/2]

template<typename T, Index Log2Dim>

bool probeValue | ( | Index | offset,
|  | ValueType & | val ) const
| inlineinherited

Return `true` if the voxel at the given offset is active.

Parameters

  | offset | the linear offset of the voxel to be probed
  [out] | val | the value of the voxel at the given coordinates

## ◆ probeValueAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

bool probeValueAndCache | ( | const Coord & | xyz,
|  | ValueType & | val,
|  | AccessorT & | ) const
| inlineinherited

Return `true` if the voxel at the given coordinates is active and return the voxel value in val.

Note
  Used internally by ValueAccessor.

## ◆ prune()

template<typename T, Index Log2Dim>

void prune | ( | const ValueType & | = zeroVal<ValueType>() | ) |
| inlineinherited

This function exists only to enable template instantiation.

## ◆ readBuffers() [1/2]

template<typename T, Index Log2Dim>

void readBuffers | ( | std::istream & | is,
|  | bool | fromHalf = false )
| inline

## ◆ readBuffers() [2/2]

template<typename T, Index Log2Dim>

void readBuffers | ( | std::istream & | is,
|  | const CoordBBox & | bbox,
|  | bool | fromHalf = false )
| inline

## ◆ readTopology()

template<typename T, Index Log2Dim>

void readTopology | ( | std::istream & | is,
|  | bool | fromHalf = false )
| inlineinherited

Read in just the topology.

Parameters

  is | the stream from which to read
  fromHalf | if true, floating-point input values are assumed to be 16-bit

## ◆ resetBackground()

template<typename T, Index Log2Dim>

void resetBackground | ( | const ValueType & | ,
|  | const ValueType & | )
| inline

## ◆ setActiveState() [1/2]

template<typename T, Index Log2Dim>

void setActiveState | ( | const Coord & | ,
|  | bool | )
| inline

## ◆ setActiveState() [2/2]

template<typename T, Index Log2Dim>

void setActiveState | ( | Index | ,
|  | bool | )
| inline

## ◆ setActiveStateAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

void setActiveStateAndCache | ( | const Coord & | ,
|  | bool | ,
|  | AccessorT & | )
| inline

## ◆ setActiveStateUnsafe()

template<typename T, Index Log2Dim>

void setActiveStateUnsafe | ( | Index | offset,
|  | bool | on )
| inlineinherited

Set the active state of the voxel at the given offset but don't change its value.

## ◆ setOffsetOn()

template<typename T, Index Log2Dim>

void setOffsetOn | ( | Index | offset,
|  | const ValueType & | val )
| inline

## ◆ setOffsetOnly()

template<typename T, Index Log2Dim>

void setOffsetOnly | ( | Index | offset,
|  | const ValueType & | val )
| inline

## ◆ setOrigin()

template<typename T, Index Log2Dim>

void setOrigin | ( | const Coord & | origin | ) |
| inlineinherited

Set the grid index coordinates of this node's local origin.

## ◆ setTransientData()

template<typename T, Index Log2Dim>

void setTransientData | ( | Index32 | transientData | ) |
| inlineinherited

Set the transient data value.

## ◆ setValue()

template<typename T, Index Log2Dim>

void setValue | ( | const Coord & | ,
|  | const ValueType & | )
| inline

## ◆ setValueAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

void setValueAndCache | ( | const Coord & | xyz,
|  | const ValueType & | val,
|  | AccessorT & | )
| inlineinherited

Change the value of the voxel at the given coordinates and mark it as active.

Note
  Used internally by ValueAccessor.

## ◆ setValueMask() [1/2]

template<typename T, Index Log2Dim>

void setValueMask | ( | const NodeMaskType & | mask | ) |
| inlineinherited

## ◆ setValueMask() [2/2]

template<typename T, Index Log2Dim>

void setValueMask | ( | Index | n,
|  | bool | on )
| inlineprotectedinherited

## ◆ setValueMaskOff()

template<typename T, Index Log2Dim>

void setValueMaskOff | ( | Index | n | ) |
| inlineprotectedinherited

## ◆ setValueMaskOn()

template<typename T, Index Log2Dim>

void setValueMaskOn | ( | Index | n | ) |
| inlineprotectedinherited

## ◆ setValueOff() [1/4]

template<typename T, Index Log2Dim>

void setValueOff | ( | const Coord & |  | ) |
| inline

## ◆ setValueOff() [2/4]

template<typename T, Index Log2Dim>

void setValueOff | ( | const Coord & | ,
|  | const ValueType & | )
| inline

## ◆ setValueOff() [3/4]

template<typename T, Index Log2Dim>

void setValueOff | ( | Index |  | ) |
| inline

## ◆ setValueOff() [4/4]

template<typename T, Index Log2Dim>

void setValueOff | ( | Index | ,
|  | const ValueType & | )
| inline

## ◆ setValueOffAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

void setValueOffAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & | )
| inline

## ◆ setValueOffUnsafe() [1/2]

template<typename T, Index Log2Dim>

void setValueOffUnsafe | ( | Index | offset | ) |
| inlineinherited

Mark the voxel at the given offset as inactive but don't change its value.

## ◆ setValueOffUnsafe() [2/2]

template<typename T, Index Log2Dim>

void setValueOffUnsafe | ( | Index | offset,
|  | const ValueType & | value )
| inlineinherited

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOn() [1/4]

template<typename T, Index Log2Dim>

void setValueOn | ( | const Coord & |  | ) |
| inline

## ◆ setValueOn() [2/4]

template<typename T, Index Log2Dim>

void setValueOn | ( | const Coord & | ,
|  | const ValueType & | )
| inline

## ◆ setValueOn() [3/4]

template<typename T, Index Log2Dim>

void setValueOn | ( | Index |  | ) |
| inline

## ◆ setValueOn() [4/4]

template<typename T, Index Log2Dim>

void setValueOn | ( | Index | ,
|  | const ValueType & | )
| inline

## ◆ setValueOnly() [1/2]

template<typename T, Index Log2Dim>

void setValueOnly | ( | const Coord & | ,
|  | const ValueType & | )
| inline

## ◆ setValueOnly() [2/2]

template<typename T, Index Log2Dim>

void setValueOnly | ( | Index | ,
|  | const ValueType & | )
| inline

## ◆ setValueOnlyAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

void setValueOnlyAndCache | ( | const Coord & | ,
|  | const ValueType & | ,
|  | AccessorT & | )
| inline

## ◆ setValueOnlyUnsafe()

template<typename T, Index Log2Dim>

void setValueOnlyUnsafe | ( | Index | offset,
|  | const ValueType & | value )
| inlineinherited

Set the value of the voxel at the given coordinates but don't change its active state.

## ◆ setValueOnUnsafe() [1/2]

template<typename T, Index Log2Dim>

void setValueOnUnsafe | ( | Index | offset | ) |
| inlineinherited

Mark the voxel at the given offset as active but don't change its value.

## ◆ setValueOnUnsafe() [2/2]

template<typename T, Index Log2Dim>

void setValueOnUnsafe | ( | Index | offset,
|  | const ValueType & | value )
| inlineinherited

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValuesOff()

template<typename T, Index Log2Dim>

void setValuesOff | ( |  | ) |
| inline

## ◆ setValuesOn()

template<typename T, Index Log2Dim>

void setValuesOn | ( |  | ) |
| inline

## ◆ signedFloodFill() [1/2]

template<typename T, Index Log2Dim>

void signedFloodFill | ( | const ValueType & |  | ) |
| inline

## ◆ signedFloodFill() [2/2]

template<typename T, Index Log2Dim>

void signedFloodFill | ( | const ValueType & | ,
|  | const ValueType & | )
| inline

## ◆ size()

template<typename T, Index Log2Dim>

Index size | ( |  | ) |
| inlinestaticinherited

Return the total number of voxels represented by this LeafNode.

## ◆ skipCompressedValues()

template<typename T, Index Log2Dim>

void skipCompressedValues | ( | bool | seekable,
|  | std::istream & | is,
|  | bool | fromHalf )
| inlineprotectedinherited

## ◆ stealNode()

template<typename T, Index Log2Dim>
template<typename NodeT>

NodeT * stealNode | ( | const Coord & | ,
|  | const ValueType & | ,
|  | bool | )
| inlineinherited

## ◆ stealNodes()

template<typename T, Index Log2Dim>
template<typename ArrayT>

void stealNodes | ( | ArrayT & | ,
|  | const ValueType & | ,
|  | bool | )
| inlineinherited

## ◆ str()

template<typename T, Index Log2Dim>

std::string str | ( |  | ) | const
| inlineinherited

Return a string representation of this node.

## ◆ streamingSize()

template<typename T, Index Log2Dim>

size_t streamingSize | ( | bool | toHalf = false | ) | const
| inherited

## ◆ swap()

template<typename T, Index Log2Dim>

void swap | ( | Buffer & | other | ) |
| inlineinherited

Exchange this node's data buffer with the given data buffer without changing the active states of the values.

## ◆ topologyDifference()

template<typename T, Index Log2Dim>
template<typename OtherType>

void topologyDifference | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & | )
| inlineinherited

Difference this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if the original voxel is active in this LeafNode and inactive in the other LeafNode.

The last dummy argument is required to match the signature for InternalNode::topologyDifference.

Note
  This operation modifies only active states, not values. Also, because it can deactivate all of this node's voxels, consider subsequently calling prune.

## ◆ topologyIntersection()

template<typename T, Index Log2Dim>
template<typename OtherType>

void topologyIntersection | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const ValueType & | )
| inlineinherited

Intersect this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active only if both of the original voxels were active.

The last dummy argument is required to match the signature for InternalNode::topologyIntersection.

Note
  This operation modifies only active states, not values. Also note that this operation can result in all voxels being inactive so consider subsequently calling prune.

## ◆ topologyUnion()

template<typename T, Index Log2Dim>
template<typename OtherType>

void topologyUnion | ( | const LeafNode< OtherType, Log2Dim > & | other,
|  | const bool | preserveTiles = false )
| inlineinherited

Union this node's set of active values with the active values of the other node, whose `ValueType` may be different. So a resulting voxel will be active if either of the original voxels were active.

Note
  This operation modifies only active states, not values.

## ◆ touchLeaf()

template<typename T, Index Log2Dim>

PointIndexLeafNode * touchLeaf | ( | const Coord & |  | ) |
| inline

Return a pointer to this node.

## ◆ touchLeafAndCache()

template<typename T, Index Log2Dim>
template<typename AccessorT>

PointIndexLeafNode * touchLeafAndCache | ( | const Coord & | ,
|  | AccessorT & | )
| inline

## ◆ transientData()

template<typename T, Index Log2Dim>

Index32 transientData | ( |  | ) | const
| inlineinherited

Return the transient data value.

## ◆ valueMask()

template<typename T, Index Log2Dim>

const NodeMaskType & valueMask | ( |  | ) | const
| inlineinherited

## ◆ voxelizeActiveTiles()

template<typename T, Index Log2Dim>

void voxelizeActiveTiles | ( | bool | = true | ) |
| inlineinherited

No-op.

This function exists only to enable template instantiation.

## ◆ writeBuffers()

template<typename T, Index Log2Dim>

void writeBuffers | ( | std::ostream & | os,
|  | bool | toHalf = false ) const
| inline

## ◆ writeTopology()

template<typename T, Index Log2Dim>

void writeTopology | ( | std::ostream & | os,
|  | bool | toHalf = false ) const
| inlineinherited

Write out just the topology.

Parameters

  os | the stream to which to write
  toHalf | if true, output floating-point values as 16-bit half floats

## Friends And Related Symbol Documentation

## ◆ PointIndexLeafNode

template<typename T, Index Log2Dim>
template<typename, Index>

friend struct PointIndexLeafNode
| friend

## ◆ tree::IteratorBase< MaskDenseIterator, PointIndexLeafNode >

template<typename T, Index Log2Dim>

friend class tree::IteratorBase< MaskDenseIterator, PointIndexLeafNode >
| friend

## ◆ tree::IteratorBase< MaskOffIterator, PointIndexLeafNode >

template<typename T, Index Log2Dim>

friend class tree::IteratorBase< MaskOffIterator, PointIndexLeafNode >
| friend

## ◆ tree::IteratorBase< MaskOnIterator, PointIndexLeafNode >

template<typename T, Index Log2Dim>

friend class tree::IteratorBase< MaskOnIterator, PointIndexLeafNode >
| friend

## Member Data Documentation

## ◆ DIM

template<typename T, Index Log2Dim>

const Index DIM
| static

## ◆ LEVEL

template<typename T, Index Log2Dim>

const Index LEVEL
| static

## ◆ LOG2DIM

template<typename T, Index Log2Dim>

const Index LOG2DIM
| static

## ◆ NUM_VALUES

template<typename T, Index Log2Dim>

const Index NUM_VALUES
| static

## ◆ NUM_VOXELS

template<typename T, Index Log2Dim>

const Index NUM_VOXELS
| static

## ◆ SIZE

template<typename T, Index Log2Dim>

const Index SIZE
| static

## ◆ TOTAL

template<typename T, Index Log2Dim>

const Index TOTAL
| static